module Rankable
	def thumbs_up
		puts "#{self.title} got a thumbs_up"
	end
end

class Movie
	include Rankable
	attr_accessor :title, :rank
	def initialize(title,rank)
		@title = title
		@rank = rank

	end
end

class Song
	include Rankable
	attr_accessor :title, :rank

	def initialize(title,rank)
		self.title = title
		self.rank = rank
	end
end

if __FILE__ == $0
	movie = Movie.new('goonies',10)
	movie.thumbs_up
	song = Song.new('Ruby baby',10)
	song.thumbs_up
end

#mixins - simply a module that has methods
# and those methods gets mixed into other classes

#we want to share some common behaviors across
#these classes which arent in the same inheritance hierchy
#(they are not in same ancestors line, no child and parent)

#mixed in modules effectively behave like superclasses.
#it changes the method look-up hierchy
#module lives in between the class that includes the
#module and their direct superclass
#so when we call a method, it looks into the object's 
#class then it looks in the module, then it looks in
#the superclass and then all the way into the top

# It generally considered better practice if
# a module depends on a method or an attribute in the 
# hosting class(the class that it gets mixed into)
# as opposted to relying on the instance variable being present






