require_relative 'rankable'

module Focus
	class Movie
		include Rankable

		attr_reader :snack_carbs,:title
		attr_accessor :rank

		def initialize(title, rank=0)
			@title = title.capitalize
			@rank = rank
			@snack_carbs = Hash.new(0)
		end

		def self.convert(line)
			title,rank = line.split(',')
			Movie.new(title,Integer(rank))
		end

		def expose_hash           
			@snack_carbs.each do |key,value|
				snack = Snack.new(key,value.to_i)
				yield(snack)
			end
		end

		def carbs_consumed
			@snack_carbs.values.reduce(0) {|sum,snack| sum + snack }
			# @snacks_carbs.values.reduce(0,:+)
		end

		def ate_snack(snack)
			@snack_carbs[snack.name] += snack.carbs
			puts "Sold ~> #{snack.name.capitalize} - #{snack.carbs} carbs" 
			puts @snack_carbs
		end

		def title=(title)
			@title = title.capitalize
		end

		def to_s
			"#{@title} with a rank of #{@rank} (#{status})"
		end
	end
end

if __FILE__ == $0
	movie1 = Focus::Movie.new("Amazing Spiderman",8)
	puts movie1
	puts movie1.normalized_rank
	movie1.thumbs_up
	movie1.thumbs_down
	puts movie1.rank
	movie1.title="crappy spiderman"
	puts movie1.title

end
