require_relative 'movie'

module Focus
	class Movie3D < Movie
		attr_accessor :wow_factor

		def initialize(title,rank,wow_factor)
			super(title,rank)

			@wow_factor = wow_factor
		end

		def thumbs_up
			self.wow_factor.times { super }
		end

		def show_effect
			puts "Wow " * self.wow_factor 
		end
	end
end

if __FILE__ == $0
	puts File.join(File.dirname(__FILE__), 'kiwi.kiwi')
	# movie3d = Movie3D.new('90%',5,10)

	# puts movie3d.cellphone
	# puts movie3d.baby
	# puts movie3d.scared
end

# polymorphism - 3dmovie and movie is a kind of relationship
# we can use 3dmovie on anywhere we expect to use movie this is polymorphism where
# we can use object A as like, object b, because OBJECT A is kind of
# object B - inherited 


# movie.show_effect
#above method that is defined in child class doesnt work on super class movie objects because
#class Movie doesnt have this method. Ruby can only search methods UP on 
#inhertiance hicharchy. only upwards, superclass and ancestors, never travel down
#on inheritance. show_effect is a new unique method defined in child class.  

#quickly show you how you can use 
#reflection(act of reflecting casting back)
#to look at the class Hierarchy
#(system of things ranked one above another)
#Class.superclass || Class.ancestors

# *take away*
# when you call a method on an object, ruby first tries
# to find that method in the objects class. If that method 
# isnt found,ruby looks in the objects super class or module defined inside
#of superclass
# and its super class and so on all the way up to the
# top of the chain

#subclasses inherit behavior(method) and 
#attributes(instance variables) from parents class.
#subclasses can also define their own unique behavior
#that wont be available in their parent class.


#subclasses can specialize(modify) behaviors(methods) by overwriting
#methods that are already defined in the parent class.
#and by using Super, they can modify existing method.

#subclasses have access to parent class's @instance variables

#we can call parent class methods on child class
#by using something called super

# class Animal
#   attr_accessor :name

#   def initialize(name)    #receives name attribute from super and invokes initialize method
#     @name = name
#   end
# end

# class BadDog < Animal
#   def initialize(age, name)
#     super(name)  #super invokes the whole initialize method in parent class and sends name attribute
#     @age = age
#   end
# end
# BadDog.new(2, "bear") => #<BadDog:0x007fb40b2beb68 @age=2, @name="bear">


# class Animal
# 	attr_accessor :name, :speed
# 	def initialize(name,speed)
# 		self.name = name
# 		self.speed = speed
# 	end

# end


# module Runnable
# 	attr_accessor :name,:speed

# 	def initialize(name,speed)
# 		self.name = name
# 		self.speed = speed
# 	end
# end

# class Cheetah
# 	include Runnable
# 	attr_accessor :power
# 	def initialize(name,speed,power)
# 		super(name,speed)

# 		@power = power
# 	end

# 	def stats
# 		puts self.name
# 		puts self.speed
# 	end

# end

# cheetah = Cheetah.new('cheetah',50,70)
# puts cheetah.name = "howdy"
# puts cheetah.stats

# animal = Animal.new('rocky',50)
# puts animal.inspect
# puts animal.name
# cheetah = Cheetah.new('cheetah',50,9000)
# puts cheetah.name, cheetah.speed,cheetah.power

# When called with specific arguments, eg. super(a, b), the specified arguments will be sent up the method lookup chain. Let's see a quick example:
# #super invokes same method(this time initialize method) its called on, so it calls on initialize of class Animal.

# This is similar to our previous example, with the difference being that super takes an argument, hence(this time on) the passed in argument is sent to the superclass. Consequently(as a result,outcome,therefore), 
#in this example when a BadDog class is created the passed in name argument ("bear") is passed to the superclass and set to the @name instance variable.


# When you call super from within a method, it will search the inheritance hierarchy for a method(that called super)by the same name and then invoke it. 

