require_relative 'dok2_and_quiet'
require_relative 'snack_bar'
require_relative 'movie'	
require_relative 'movie3d' 

module Focus
	class Playlist
		attr_reader :movies, :name

		def initialize(name)
			@name = name.capitalize
			@movies = []
			puts "\n***#{@name}'s Playlist has been created***"
		end

		def name=(title)
			@name = title.capitalize
			puts "Name of playlist has been modified to #{@name}"
		end	

		def load_file(from_file)
			puts "\n::::Loding File #{from_file.capitalize}::::"
			File.readlines(from_file).each do |line|
				add_movie(Movie.convert(line))
			end
		end

		def save_file(to_file="final_records")
			puts "\n::::::Saving To File #{to_file.capitalize}::::::"
			File.open(to_file,"a+") do |file|
				@movies.sort.map.with_index(1) do |movie, i|
					file.puts("\t#{i}.#{movie.title},#{movie.rank}")
				end
				time = Time.new
				file.puts time.strftime("Printed on %m/%d/%Y at %I:%M%p")
			end
		end

		def add_movie(movie)
			@movies << movie
			puts "::added #{movie.title}::"
		end

		def play(viewings)

			puts "\n\n~~Playing #{@name}'s playlist:~~"

			@movies.sort {|x,y| y.rank <=> x.rank}.each do |movie|
				puts "\tTrack: #{movie}"
			end

			snacks = SnackBar::SNACKS
			puts "\nThere are #{snacks.size} snacks available in the Snack Bar."
			snacks.sort {|x,y| y.carbs <=> x.carbs }.map.with_index(1) {|snack,i| puts "\t#{i}. #{snack.name.capitalize} - #{snack.carbs} carbs"}

			puts "\nStarting the Movie,Enjoy your show!!"
			1.upto(viewings) do |counter|
				puts "\nViewing: #{counter}"
				@movies.sort.each do |movie|
					Dok2AndQuiet.review(movie)
					snack = SnackBar.random
					movie.ate_snack(snack)
					puts movie
					puts "**************************************************"
				end
			end
		end

		def total_playlist_carbs
			@movies.reduce(0) {|sum,movie| sum + movie.carbs_consumed}
		end

		def total_playlist_snacks 
			@movies.reduce(0) {|sum, movie| sum + movie.snack_carbs.keys.size}
		end


		def print_stats
			puts "\n\n\nPlayList #{@name.upcase!}'s Stats: #{total_playlist_carbs} carbs - #{total_playlist_snacks} snacks"

			@movies.sort {|x,y| y.carbs_consumed <=> x.carbs_consumed }.map.with_index(1) do |movie,i| 
				puts "#{i}. #{movie.title} - #{movie.carbs_consumed} *total* grand carbs"
				movie.expose_hash {|key| puts "\t #{key.name} - #{key.carbs} carbs"}
			end

			hits, flops = @movies.partition {|m| m.hit? }

			puts "\nHits: "
			hits.sort.each do |movie| 
				puts "\t#{movie}"
			end


			puts "\nFlops: "
			flops.sort.each do |movie|
				puts "\t#{movie}"
			end
		end
	end
end


if __FILE__ == $0
	playlist1 = Focus::Playlist.new("Mastering Ruby 1")
	movie1 = Focus::Movie.new("Knowledge and Skill",10)
	movie2 = Focus::Movie.new("Focus",20)
	playlist1.add_movie(movie1)
	playlist1.add_movie(movie2)
	# puts playlist1.movies
	# puts playlist1.name
	playlist1.play(3)
end

